// HalloWeltGUI2.java                           MM 2009

import java.awt.*;                             // Color
import javax.swing.*;          //JFrame, JPanel, JLabel
import java.awt.event.*;                    // Listener

/**
 * Ausgabe des Schriftzugs "Hallo Welt!",
 * Erzeugen eines Fensters mit Text und Button.
 */
public class HalloWeltGUI2
  extends JFrame
  implements ActionListener
{
/* ------------------------------------------------- */
                                                // View
/**
 * Konstante, Aendern der Hintergrundfarbe.
 */
  public static final String ACTION_SET = "Set";

/**
 * Konstante, Beenden des Programms.
 */
  public static final String ACTION_QUIT = "Quit";

/**
 * Content Pane, Darstellungsbereich des Fensters.
 */
  private JPanel contentPane;

/**
 * Konstruktor, baut das Fenster auf.
 * @param titel Titelleistentext
 * @param farbe Fensterhintergrundfarbe
 */
  public HalloWeltGUI2( String titel, Color farbe)
  {
// Titelleiste
    super( titel);

// Darstellungsbereich
    contentPane = new JPanel();
    contentPane.setBackground( farbe);
                             // Button Set mit Listener
    JButton btSet = new JButton( ACTION_SET);
    contentPane.add( btSet);
    btSet.addActionListener( this);
                                         // Label Hallo
    JLabel lbHallo = new JLabel( "Hallo Welt!");
    contentPane.add( lbHallo);
                            // Button Quit mit Listener
    JButton btQuit = new JButton( ACTION_QUIT);
    contentPane.add( btQuit);
    btQuit.addActionListener( this);

// Fenster
                           // Fensterinhalt uebernehmen
    setContentPane( contentPane);
    pack();              // Anpassen der Fenstergroesse
                              // Beenden durch x-Button
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE);
    setVisible( true);                // Sichtbarmachen
  }

/* ------------------------------------------------- */
                                          // Controller
/**
 * Ereignisverarbeitung, ActionListener,
 * Betaetigen eines Button.
 */
  public void actionPerformed( ActionEvent ae)
  {
    String command = ae.getActionCommand();

// Farbwechsel durch Button Set
    if( command.equals( ACTION_SET))
    {
      float dummy1 = ( float)Math.random();
      float dummy2 = ( float)Math.random();
      float dummy3 = ( float)Math.random();
      Color farbe = new Color( dummy1, dummy2, dummy3);

      contentPane.setBackground( farbe);
    }

// Programmabbruch durch Button Quit
    if( command.equals( ACTION_QUIT))
    {
      System.exit( 0);
    }
  }

/* ------------------------------------------------- */
/**
 * Hauptmethode, erzeugt Fenster mit Schrift und Button.
 */
  public static void main(String args[])
  {
    HalloWeltGUI2 hallo = 
      new HalloWeltGUI2( "Hallo Welt", Color.yellow);
  }
}
